# SHA1 gem
require 'digest/sha1'

# The main RequestTokenGenerator driver
class RequestTokenGenerator
	# The secret key
	@secret_key = ""
	# The the concatenated string from hash's key:value
	@post_string = ""
	# The concatenation symbol
	@concat_symbol = '+'
	# The key:value symbol
	@kv_symbol = ':'

	# Set secret key
	#
	# @param secret_key [String] the secret key string.
	# @return nil
	def self.set_secret(secret_key)
		@secret_key = secret_key
	end
	
	# Generates token and appends to current hash.
	#
	# @param hash [Hash] the hash with request parameters.
	# @return [Hash] the hash parameter with added token string.
	
	def self.generate(hash = {})

		hash.each { |key, value| 			
			@post_string << "#{key}" << @kv_symbol << "#{value}" << @concat_symbol;
		}
		
		@post_string << "secret_key" + @kv_symbol << @secret_key
							
		@request_token = Digest::SHA1.hexdigest @post_string
		
		request_token_hash = Hash.new
		
		request_token_hash["request_token"] = @request_token
				
		return hash.merge(request_token_hash)
	end
	
	
end

